import { NDKEvent, type NDKEventId, NDKKind } from '@nostr-dev-kit/ndk';

export class LetterToFolderMapping {
	message: NDKEventId;
	folder: NDKEventId;

	constructor() {
		this.message = '';
		this.folder = '';
	}

	static async fromDecryptedMessage(
		decryptedMessage: NDKEvent,
		encryptedMessage: NDKEvent
	): Promise<LetterToFolderMapping> {
		if (decryptedMessage.kind !== NDKKind.Label) throw new Error('Not a label');
		let labelType = decryptedMessage.tags.find((t) => t[0] === 'label-type')?.[1];
		if (!labelType) throw new Error('No label type');
		if (labelType !== 'letter-to-folder-mapping') throw new Error('Not a letter-to-folder-mapping');
		let mapping = new LetterToFolderMapping();
		mapping.message = decryptedMessage.tags.find((t) => t[0] === 'message')?.[1] ?? '';
		mapping.folder = decryptedMessage.tags.find((t) => t[0] === 'folder')?.[1] ?? '';
		return mapping;
	}
}
